- name: "Lookups {{ templatename }} object"
  async: 30
  changed_when: False
  k8s_info:
    api_version: "{{ apivers }}"
    kind: "{{ objectkind }}"
    namespace: "{{ buildns }}"
    name: "{{ templatename }}"
  no_log: True
  poll: 5
  register: has_obj
# NOTE:
# While k8s returns with `{"changed":false,...}`, re-applying Tasks, Triggers
# or Pipelines triggers a new run, re-applying the whole role in a loop
# A workaround is then to internally version those objects, and assume we
# do not need to re-apply them, as long as our internal version matches
- name: "Installs {{ templatename }}"
  async: 30
  k8s:
    definition: "{{ lookup('template', templatefile) }}"
  poll: 5
  when:
  - has_obj is defined
  - has_obj.resources is defined
  - >
      has_obj.resources | length == 0
      or (has_obj.resources | length > 0
          and has_obj.resources[0].metadata is defined
          and ((has_obj.resources[0].metadata.labels is not defined
                or (has_obj.resources[0].metadata.labels['version'] is not defined
                    or (has_obj.resources[0].metadata.labels['version'] | default('')) != tekton_assets_version))
               or (has_obj.resources[0].kind | default(False) == 'Pipeline'
                   and ((has_obj.resources[0].metadata.labels['scan-code'] | default('')) != scan_code_with
                        or (has_obj.resources[0].metadata.labels['scan-image'] | default('')) != scan_images_with
                        or (has_obj.resources[0].metadata.labels['scan-repo'] | default('')) != scan_repos_with
                        or (has_obj.resources[0].metadata.labels['sign-image'] | default('')) != sign_images_with))))
